// Generated by BUCKLESCRIPT VERSION 3.1.5, PLEASE EDIT WITH CARE
'use strict';

var $$Map = require("bs-platform/lib/js/map.js");
var $$Set = require("bs-platform/lib/js/set.js");
var List = require("bs-platform/lib/js/list.js");
var Block = require("bs-platform/lib/js/block.js");
var Curry = require("bs-platform/lib/js/curry.js");
var Js_option = require("bs-platform/lib/js/js_option.js");
var ReasonReact = require("reason-react/src/ReasonReact.js");
var Formality__Utils = require("./Formality__Utils.bs.js");
var Formality__Validation = require("./Formality__Validation.bs.js");
var Caml_builtin_exceptions = require("bs-platform/lib/js/caml_builtin_exceptions.js");

function Make(Form) {
  var FieldsSetOrigin = $$Set.Make(/* module */[/* compare */Formality__Utils.comparator]);
  var empty = FieldsSetOrigin[/* empty */0];
  var isEmpty = FieldsSetOrigin[/* is_empty */1];
  var mem = FieldsSetOrigin[/* mem */2];
  var add = FieldsSetOrigin[/* add */3];
  var remove = FieldsSetOrigin[/* remove */5];
  var FieldsSet = /* module */[
    /* empty */empty,
    /* isEmpty */isEmpty,
    /* mem */mem,
    /* add */add,
    /* remove */remove
  ];
  var ResultsMapOrigin = $$Map.Make(/* module */[/* compare */Formality__Utils.comparator]);
  var empty$1 = ResultsMapOrigin[/* empty */0];
  var add$1 = ResultsMapOrigin[/* add */3];
  var get = function (key, map) {
    try {
      return Curry._2(ResultsMapOrigin[/* find */21], key, map);
    }
    catch (exn){
      if (exn === Caml_builtin_exceptions.not_found) {
        return /* None */0;
      } else {
        throw exn;
      }
    }
  };
  var ResultsMap = /* module */[
    /* empty */empty$1,
    /* add */add$1,
    /* get */get
  ];
  var getInitialState = function (data) {
    return /* record */[
            /* data */data,
            /* status : Editing */0,
            /* results */empty$1,
            /* validating */empty,
            /* submittedOnce */false,
            /* emittedFields */empty
          ];
  };
  var debounce = function (validateAsync, wait) {
    var lastSelf = [/* None */0];
    var lastField = [/* None */0];
    var lastValue = [/* None */0];
    var lastCallTime = [/* None */0];
    var timerId = [/* None */0];
    var shouldInvoke = function (time) {
      var match = lastCallTime[0];
      if (match) {
        var timeSinceLastCall = time - match[0] | 0;
        if (timeSinceLastCall >= wait) {
          return true;
        } else {
          return timeSinceLastCall < 0;
        }
      } else {
        return true;
      }
    };
    var remainingWait = function (time) {
      var match = lastCallTime[0];
      if (match) {
        var timeSinceLastCall = time - match[0] | 0;
        return wait - timeSinceLastCall | 0;
      } else {
        return wait;
      }
    };
    var timerExpired = function () {
      var time = Date.now() | 0;
      var match = shouldInvoke(time);
      if (match) {
        timerId[0] = /* None */0;
        if (Js_option.isSome(lastValue[0])) {
          var field = lastField[0];
          var value = lastValue[0];
          var self = lastSelf[0];
          lastSelf[0] = /* None */0;
          lastValue[0] = /* None */0;
          if (field && value && self) {
            return Curry._1(self[0][/* send */3], /* TriggerAsyncValidation */Block.__(3, [
                          field[0],
                          value[0],
                          validateAsync
                        ]));
          } else {
            return /* () */0;
          }
        } else {
          return 0;
        }
      } else {
        timerId[0] = /* Some */[setTimeout(timerExpired, remainingWait(time))];
        return /* () */0;
      }
    };
    return (function (field, value, self) {
        var time = Date.now() | 0;
        lastCallTime[0] = /* Some */[time];
        lastField[0] = /* Some */[field];
        lastValue[0] = /* Some */[value];
        lastSelf[0] = /* Some */[self];
        timerId[0] = /* Some */[setTimeout(timerExpired, wait)];
        return /* () */0;
      });
  };
  var debouncedValidators = Curry._2(Form[/* Validators */5][/* map */2], (function (validator) {
          var match = validator[/* validateAsync */3];
          if (match) {
            return /* record */[
                    /* strategy */validator[/* strategy */0],
                    /* dependents */validator[/* dependents */1],
                    /* validate */validator[/* validate */2],
                    /* validateAsync : Some */[debounce(match[0], Form[/* debounceInterval */3])]
                  ];
          } else {
            return /* record */[
                    /* strategy */validator[/* strategy */0],
                    /* dependents */validator[/* dependents */1],
                    /* validate */validator[/* validate */2],
                    /* validateAsync : None */0
                  ];
          }
        }), Form[/* validators */4]);
  var getValidator = function (field) {
    var exit = 0;
    var validator;
    try {
      validator = Curry._2(Form[/* Validators */5][/* find */0], field, debouncedValidators);
      exit = 1;
    }
    catch (exn){
      if (exn === Caml_builtin_exceptions.not_found) {
        return /* None */0;
      } else {
        throw exn;
      }
    }
    if (exit === 1) {
      return /* Some */[validator];
    }
    
  };
  var validateDependents = function (data, results, emittedFields, dependents) {
    return List.fold_left((function (param, field$prime) {
                  var emittedFields$prime = param[1];
                  var results$prime = param[0];
                  var validator = getValidator(field$prime);
                  var emitted = Curry._2(mem, field$prime, emittedFields);
                  if (validator) {
                    if (emitted) {
                      var value = Curry._2(Form[/* get */0], field$prime, data);
                      var result = Curry._2(validator[0][/* validate */2], value, data);
                      var match = Curry._1(Form[/* valueEmpty */2], value);
                      return /* tuple */[
                              Curry._3(add$1, field$prime, result ? /* Some */[result] : (
                                      match ? /* None */0 : /* Some */[result]
                                    ), results$prime),
                              Curry._2(add, field$prime, emittedFields$prime)
                            ];
                    } else {
                      return /* tuple */[
                              results$prime,
                              emittedFields$prime
                            ];
                    }
                  } else {
                    return /* tuple */[
                            results$prime,
                            emittedFields$prime
                          ];
                  }
                }), /* tuple */[
                results,
                emittedFields
              ], dependents);
  };
  var component = ReasonReact.reducerComponent("FormalityForm");
  var make = function (initialState, onSubmit, children) {
    return /* record */[
            /* debugName */component[/* debugName */0],
            /* reactClassInternal */component[/* reactClassInternal */1],
            /* handedOffState */component[/* handedOffState */2],
            /* willReceiveProps */component[/* willReceiveProps */3],
            /* didMount */component[/* didMount */4],
            /* didUpdate */component[/* didUpdate */5],
            /* willUnmount */component[/* willUnmount */6],
            /* willUpdate */component[/* willUpdate */7],
            /* shouldUpdate */component[/* shouldUpdate */8],
            /* render */(function (param) {
                var send = param[/* send */3];
                var state = param[/* state */1];
                return Curry._1(children, /* record */[
                            /* state */state[/* data */0],
                            /* status */state[/* status */1],
                            /* results */(function (field) {
                                return get(field, state[/* results */2]);
                              }),
                            /* validating */(function (field) {
                                return Curry._2(mem, field, state[/* validating */3]);
                              }),
                            /* submitting */state[/* status */1] === /* Submitting */1,
                            /* change */(function (field, value) {
                                return Curry._1(send, /* Change */Block.__(0, [/* tuple */[
                                                field,
                                                value
                                              ]]));
                              }),
                            /* blur */(function (field, value) {
                                return Curry._1(send, /* Blur */Block.__(1, [/* tuple */[
                                                field,
                                                value
                                              ]]));
                              }),
                            /* submit */(function () {
                                return Curry._1(send, /* Submit */0);
                              }),
                            /* dismissSubmissionResult */(function () {
                                return Curry._1(send, /* DismissSubmissionResult */1);
                              })
                          ]);
              }),
            /* initialState */(function () {
                return getInitialState(initialState);
              }),
            /* retainedProps */component[/* retainedProps */11],
            /* reducer */(function (action, state) {
                if (typeof action === "number") {
                  switch (action) {
                    case 0 : 
                        var match = Curry._1(isEmpty, state[/* validating */3]);
                        var match$1 = state[/* status */1];
                        var exit = 0;
                        if (match && !(typeof match$1 === "number" && match$1 === 1)) {
                          exit = 1;
                        } else {
                          return /* NoUpdate */0;
                        }
                        if (exit === 1) {
                          var match$2 = Curry._3(Form[/* Validators */5][/* fold */1], (function (field$prime, validator$prime, param) {
                                  var results$prime = param[1];
                                  var value = Curry._2(Form[/* get */0], field$prime, state[/* data */0]);
                                  var match = get(field$prime, results$prime);
                                  var currentResultInvalid = match && match[0] ? true : false;
                                  var result = Curry._2(validator$prime[/* validate */2], value, state[/* data */0]);
                                  var match$1 = validator$prime[/* validateAsync */3];
                                  var results;
                                  var exit = 0;
                                  if (currentResultInvalid) {
                                    if (result) {
                                      results = Curry._3(add$1, field$prime, /* Some */[result], results$prime);
                                    } else if (match$1) {
                                      results = results$prime;
                                    } else {
                                      exit = 1;
                                    }
                                  } else {
                                    exit = 1;
                                  }
                                  if (exit === 1) {
                                    if (result) {
                                      results = Curry._3(add$1, field$prime, /* Some */[result], results$prime);
                                    } else {
                                      var match$2 = Curry._1(Form[/* valueEmpty */2], value);
                                      results = Curry._3(add$1, field$prime, match$2 ? /* None */0 : /* Some */[result], results$prime);
                                    }
                                  }
                                  var match$3 = get(field$prime, results);
                                  if (param[0]) {
                                    if (match$3) {
                                      if (match$3[0]) {
                                        return /* tuple */[
                                                false,
                                                results
                                              ];
                                      } else {
                                        return /* tuple */[
                                                true,
                                                results
                                              ];
                                      }
                                    } else {
                                      return /* tuple */[
                                              true,
                                              results
                                            ];
                                    }
                                  } else {
                                    return /* tuple */[
                                            false,
                                            results
                                          ];
                                  }
                                }), debouncedValidators, /* tuple */[
                                true,
                                state[/* results */2]
                              ]);
                          var results = match$2[1];
                          if (match$2[0]) {
                            return /* UpdateWithSideEffects */Block.__(2, [
                                      /* record */[
                                        /* data */state[/* data */0],
                                        /* status : Submitting */1,
                                        /* results */results,
                                        /* validating */state[/* validating */3],
                                        /* submittedOnce */true,
                                        /* emittedFields */state[/* emittedFields */5]
                                      ],
                                      (function (param) {
                                          var send = param[/* send */3];
                                          return Curry._2(onSubmit, param[/* state */1][/* data */0], /* record */[
                                                      /* notifyOnSuccess */(function (data) {
                                                          return Curry._1(send, /* SetSubmittedStatus */Block.__(5, [data]));
                                                        }),
                                                      /* notifyOnFailure */(function (fieldLevelErrors, serverMessage) {
                                                          return Curry._1(send, /* SetSubmissionFailedStatus */Block.__(6, [
                                                                        fieldLevelErrors,
                                                                        serverMessage
                                                                      ]));
                                                        }),
                                                      /* reset */(function () {
                                                          return Curry._1(send, /* Reset */2);
                                                        })
                                                    ]);
                                        })
                                    ]);
                          } else {
                            return /* Update */Block.__(0, [/* record */[
                                        /* data */state[/* data */0],
                                        /* status : Editing */0,
                                        /* results */results,
                                        /* validating */state[/* validating */3],
                                        /* submittedOnce */true,
                                        /* emittedFields */state[/* emittedFields */5]
                                      ]]);
                          }
                        }
                        break;
                    case 1 : 
                        var match$3 = state[/* status */1];
                        var exit$1 = 0;
                        if (typeof match$3 === "number" && match$3 < 2) {
                          return /* NoUpdate */0;
                        } else {
                          exit$1 = 1;
                        }
                        if (exit$1 === 1) {
                          return /* Update */Block.__(0, [/* record */[
                                      /* data */state[/* data */0],
                                      /* status : Editing */0,
                                      /* results */state[/* results */2],
                                      /* validating */state[/* validating */3],
                                      /* submittedOnce */state[/* submittedOnce */4],
                                      /* emittedFields */state[/* emittedFields */5]
                                    ]]);
                        }
                        break;
                    case 2 : 
                        return /* Update */Block.__(0, [getInitialState(initialState)]);
                    
                  }
                } else {
                  switch (action.tag | 0) {
                    case 0 : 
                        var match$4 = action[0];
                        var value = match$4[1];
                        var field = match$4[0];
                        var data = Curry._2(Form[/* update */1], /* tuple */[
                              field,
                              value
                            ], state[/* data */0]);
                        var match$5 = getValidator(field);
                        if (match$5) {
                          var validator = match$5[0];
                          var emitted = Curry._2(mem, field, state[/* emittedFields */5]);
                          var match$6 = validator[/* strategy */0];
                          var match$7 = state[/* submittedOnce */4];
                          var exit$2 = 0;
                          if (emitted || match$7) {
                            exit$2 = 3;
                          } else {
                            switch (match$6) {
                              case 1 : 
                                  exit$2 = 3;
                                  break;
                              case 2 : 
                              case 3 : 
                                  exit$2 = 1;
                                  break;
                              case 0 : 
                              case 4 : 
                                  exit$2 = 2;
                                  break;
                              
                            }
                          }
                          switch (exit$2) {
                            case 1 : 
                                var match$8 = validator[/* validateAsync */3];
                                if (match$8) {
                                  var validateAsync = match$8[0];
                                  var match$9 = validator[/* dependents */1];
                                  if (match$9) {
                                    var match$10 = validateDependents(data, state[/* results */2], state[/* emittedFields */5], match$9[0]);
                                    var emittedFields = match$10[1];
                                    var results$1 = match$10[0];
                                    return Formality__Validation.ifResult((function () {
                                                  return /* UpdateWithSideEffects */Block.__(2, [
                                                            /* record */[
                                                              /* data */data,
                                                              /* status */state[/* status */1],
                                                              /* results */Curry._3(add$1, field, /* None */0, results$1),
                                                              /* validating */Curry._2(add, field, state[/* validating */3]),
                                                              /* submittedOnce */state[/* submittedOnce */4],
                                                              /* emittedFields */Curry._2(add, field, emittedFields)
                                                            ],
                                                            (function (param) {
                                                                return Curry._1(param[/* send */3], /* InvokeDebouncedAsyncValidation */Block.__(2, [
                                                                              field,
                                                                              value,
                                                                              validateAsync
                                                                            ]));
                                                              })
                                                          ]);
                                                }), (function () {
                                                  return /* Update */Block.__(0, [/* record */[
                                                              /* data */data,
                                                              /* status */state[/* status */1],
                                                              /* results */results$1,
                                                              /* validating */state[/* validating */3],
                                                              /* submittedOnce */state[/* submittedOnce */4],
                                                              /* emittedFields */emittedFields
                                                            ]]);
                                                }), Curry._2(validator[/* validate */2], value, data));
                                  } else {
                                    return Formality__Validation.ifResult((function () {
                                                  return /* UpdateWithSideEffects */Block.__(2, [
                                                            /* record */[
                                                              /* data */data,
                                                              /* status */state[/* status */1],
                                                              /* results */Curry._3(add$1, field, /* None */0, state[/* results */2]),
                                                              /* validating */Curry._2(add, field, state[/* validating */3]),
                                                              /* submittedOnce */state[/* submittedOnce */4],
                                                              /* emittedFields */Curry._2(add, field, state[/* emittedFields */5])
                                                            ],
                                                            (function (param) {
                                                                return Curry._1(param[/* send */3], /* InvokeDebouncedAsyncValidation */Block.__(2, [
                                                                              field,
                                                                              value,
                                                                              validateAsync
                                                                            ]));
                                                              })
                                                          ]);
                                                }), (function () {
                                                  return /* Update */Block.__(0, [/* record */[
                                                              /* data */data,
                                                              /* status */state[/* status */1],
                                                              /* results */state[/* results */2],
                                                              /* validating */state[/* validating */3],
                                                              /* submittedOnce */state[/* submittedOnce */4],
                                                              /* emittedFields */state[/* emittedFields */5]
                                                            ]]);
                                                }), Curry._2(validator[/* validate */2], value, data));
                                  }
                                } else {
                                  return Formality__Validation.ifResult((function (result) {
                                                var match = validator[/* dependents */1];
                                                if (match) {
                                                  var match$1 = validateDependents(data, state[/* results */2], state[/* emittedFields */5], match[0]);
                                                  var match$2 = Curry._1(Form[/* valueEmpty */2], value);
                                                  return /* Update */Block.__(0, [/* record */[
                                                              /* data */data,
                                                              /* status */state[/* status */1],
                                                              /* results */Curry._3(add$1, field, match$2 ? /* None */0 : /* Some */[result], match$1[0]),
                                                              /* validating */state[/* validating */3],
                                                              /* submittedOnce */state[/* submittedOnce */4],
                                                              /* emittedFields */Curry._2(add, field, match$1[1])
                                                            ]]);
                                                } else {
                                                  var match$3 = Curry._1(Form[/* valueEmpty */2], value);
                                                  return /* Update */Block.__(0, [/* record */[
                                                              /* data */data,
                                                              /* status */state[/* status */1],
                                                              /* results */Curry._3(add$1, field, match$3 ? /* None */0 : /* Some */[result], state[/* results */2]),
                                                              /* validating */state[/* validating */3],
                                                              /* submittedOnce */state[/* submittedOnce */4],
                                                              /* emittedFields */Curry._2(add, field, state[/* emittedFields */5])
                                                            ]]);
                                                }
                                              }), (function () {
                                                var match = validator[/* dependents */1];
                                                if (match) {
                                                  var match$1 = validateDependents(data, state[/* results */2], state[/* emittedFields */5], match[0]);
                                                  return /* Update */Block.__(0, [/* record */[
                                                              /* data */data,
                                                              /* status */state[/* status */1],
                                                              /* results */match$1[0],
                                                              /* validating */state[/* validating */3],
                                                              /* submittedOnce */state[/* submittedOnce */4],
                                                              /* emittedFields */match$1[1]
                                                            ]]);
                                                } else {
                                                  return /* Update */Block.__(0, [/* record */[
                                                              /* data */data,
                                                              /* status */state[/* status */1],
                                                              /* results */state[/* results */2],
                                                              /* validating */state[/* validating */3],
                                                              /* submittedOnce */state[/* submittedOnce */4],
                                                              /* emittedFields */state[/* emittedFields */5]
                                                            ]]);
                                                }
                                              }), Curry._2(validator[/* validate */2], value, data));
                                }
                            case 2 : 
                                return /* Update */Block.__(0, [/* record */[
                                            /* data */data,
                                            /* status */state[/* status */1],
                                            /* results */state[/* results */2],
                                            /* validating */state[/* validating */3],
                                            /* submittedOnce */state[/* submittedOnce */4],
                                            /* emittedFields */state[/* emittedFields */5]
                                          ]]);
                            case 3 : 
                                var match$11 = validator[/* validateAsync */3];
                                if (match$11) {
                                  var validateAsync$1 = match$11[0];
                                  var match$12 = validator[/* dependents */1];
                                  if (match$12) {
                                    var match$13 = validateDependents(data, state[/* results */2], state[/* emittedFields */5], match$12[0]);
                                    var emittedFields$1 = match$13[1];
                                    var results$2 = match$13[0];
                                    return Formality__Validation.ifResult((function () {
                                                  return /* UpdateWithSideEffects */Block.__(2, [
                                                            /* record */[
                                                              /* data */data,
                                                              /* status */state[/* status */1],
                                                              /* results */Curry._3(add$1, field, /* None */0, results$2),
                                                              /* validating */Curry._2(add, field, state[/* validating */3]),
                                                              /* submittedOnce */state[/* submittedOnce */4],
                                                              /* emittedFields */Curry._2(add, field, emittedFields$1)
                                                            ],
                                                            (function (param) {
                                                                return Curry._1(param[/* send */3], /* InvokeDebouncedAsyncValidation */Block.__(2, [
                                                                              field,
                                                                              value,
                                                                              validateAsync$1
                                                                            ]));
                                                              })
                                                          ]);
                                                }), (function (result) {
                                                  return /* Update */Block.__(0, [/* record */[
                                                              /* data */data,
                                                              /* status */state[/* status */1],
                                                              /* results */Curry._3(add$1, field, /* Some */[result], results$2),
                                                              /* validating */Curry._2(remove, field, state[/* validating */3]),
                                                              /* submittedOnce */state[/* submittedOnce */4],
                                                              /* emittedFields */Curry._2(add, field, emittedFields$1)
                                                            ]]);
                                                }), Curry._2(validator[/* validate */2], value, data));
                                  } else {
                                    return Formality__Validation.ifResult((function () {
                                                  return /* UpdateWithSideEffects */Block.__(2, [
                                                            /* record */[
                                                              /* data */data,
                                                              /* status */state[/* status */1],
                                                              /* results */Curry._3(add$1, field, /* None */0, state[/* results */2]),
                                                              /* validating */Curry._2(add, field, state[/* validating */3]),
                                                              /* submittedOnce */state[/* submittedOnce */4],
                                                              /* emittedFields */Curry._2(add, field, state[/* emittedFields */5])
                                                            ],
                                                            (function (param) {
                                                                return Curry._1(param[/* send */3], /* InvokeDebouncedAsyncValidation */Block.__(2, [
                                                                              field,
                                                                              value,
                                                                              validateAsync$1
                                                                            ]));
                                                              })
                                                          ]);
                                                }), (function (result) {
                                                  return /* Update */Block.__(0, [/* record */[
                                                              /* data */data,
                                                              /* status */state[/* status */1],
                                                              /* results */Curry._3(add$1, field, /* Some */[result], state[/* results */2]),
                                                              /* validating */Curry._2(remove, field, state[/* validating */3]),
                                                              /* submittedOnce */state[/* submittedOnce */4],
                                                              /* emittedFields */Curry._2(add, field, state[/* emittedFields */5])
                                                            ]]);
                                                }), Curry._2(validator[/* validate */2], value, data));
                                  }
                                } else {
                                  var match$14 = validator[/* dependents */1];
                                  if (match$14) {
                                    var result = Curry._2(validator[/* validate */2], value, data);
                                    var match$15 = validateDependents(data, state[/* results */2], state[/* emittedFields */5], match$14[0]);
                                    var match$16 = Curry._1(Form[/* valueEmpty */2], value);
                                    return /* Update */Block.__(0, [/* record */[
                                                /* data */data,
                                                /* status */state[/* status */1],
                                                /* results */Curry._3(add$1, field, result ? /* Some */[result] : (
                                                        match$16 ? /* None */0 : /* Some */[result]
                                                      ), match$15[0]),
                                                /* validating */state[/* validating */3],
                                                /* submittedOnce */state[/* submittedOnce */4],
                                                /* emittedFields */Curry._2(add, field, match$15[1])
                                              ]]);
                                  } else {
                                    var result$1 = Curry._2(validator[/* validate */2], value, data);
                                    var match$17 = Curry._1(Form[/* valueEmpty */2], value);
                                    return /* Update */Block.__(0, [/* record */[
                                                /* data */data,
                                                /* status */state[/* status */1],
                                                /* results */Curry._3(add$1, field, result$1 ? /* Some */[result$1] : (
                                                        match$17 ? /* None */0 : /* Some */[result$1]
                                                      ), state[/* results */2]),
                                                /* validating */state[/* validating */3],
                                                /* submittedOnce */state[/* submittedOnce */4],
                                                /* emittedFields */Curry._2(add, field, state[/* emittedFields */5])
                                              ]]);
                                  }
                                }
                            
                          }
                        } else {
                          return /* Update */Block.__(0, [/* record */[
                                      /* data */data,
                                      /* status */state[/* status */1],
                                      /* results */state[/* results */2],
                                      /* validating */state[/* validating */3],
                                      /* submittedOnce */state[/* submittedOnce */4],
                                      /* emittedFields */state[/* emittedFields */5]
                                    ]]);
                        }
                        break;
                    case 1 : 
                        var match$18 = action[0];
                        var value$1 = match$18[1];
                        var field$1 = match$18[0];
                        var validator$1 = getValidator(field$1);
                        var emitted$1 = Curry._2(mem, field$1, state[/* emittedFields */5]);
                        if (validator$1 && !emitted$1) {
                          var validator$2 = validator$1[0];
                          var match$19 = validator$2[/* strategy */0];
                          var exit$3 = 0;
                          if (match$19 !== 3 && match$19 !== 0) {
                            return /* NoUpdate */0;
                          } else {
                            exit$3 = 1;
                          }
                          if (exit$3 === 1) {
                            var match$20 = validator$2[/* validateAsync */3];
                            if (match$20) {
                              var validateAsync$2 = match$20[0];
                              return Formality__Validation.ifResult((function () {
                                            return /* UpdateWithSideEffects */Block.__(2, [
                                                      /* record */[
                                                        /* data */state[/* data */0],
                                                        /* status */state[/* status */1],
                                                        /* results */Curry._3(add$1, field$1, /* None */0, state[/* results */2]),
                                                        /* validating */Curry._2(add, field$1, state[/* validating */3]),
                                                        /* submittedOnce */state[/* submittedOnce */4],
                                                        /* emittedFields */Curry._2(add, field$1, state[/* emittedFields */5])
                                                      ],
                                                      (function (param) {
                                                          return Curry._1(param[/* send */3], /* InvokeDebouncedAsyncValidation */Block.__(2, [
                                                                        field$1,
                                                                        value$1,
                                                                        validateAsync$2
                                                                      ]));
                                                        })
                                                    ]);
                                          }), (function (result) {
                                            return /* Update */Block.__(0, [/* record */[
                                                        /* data */state[/* data */0],
                                                        /* status */state[/* status */1],
                                                        /* results */Curry._3(add$1, field$1, /* Some */[result], state[/* results */2]),
                                                        /* validating */Curry._2(remove, field$1, state[/* validating */3]),
                                                        /* submittedOnce */state[/* submittedOnce */4],
                                                        /* emittedFields */Curry._2(add, field$1, state[/* emittedFields */5])
                                                      ]]);
                                          }), Curry._2(validator$2[/* validate */2], value$1, state[/* data */0]));
                            } else {
                              var result$2 = Curry._2(validator$2[/* validate */2], value$1, state[/* data */0]);
                              var match$21 = Curry._1(Form[/* valueEmpty */2], value$1);
                              return /* Update */Block.__(0, [/* record */[
                                          /* data */state[/* data */0],
                                          /* status */state[/* status */1],
                                          /* results */Curry._3(add$1, field$1, result$2 ? /* Some */[result$2] : (
                                                  match$21 ? /* None */0 : /* Some */[result$2]
                                                ), state[/* results */2]),
                                          /* validating */state[/* validating */3],
                                          /* submittedOnce */state[/* submittedOnce */4],
                                          /* emittedFields */Curry._2(add, field$1, state[/* emittedFields */5])
                                        ]]);
                            }
                          }
                          
                        } else {
                          return /* NoUpdate */0;
                        }
                        break;
                    case 2 : 
                        var validateAsync$3 = action[2];
                        var value$2 = action[1];
                        var field$2 = action[0];
                        return /* SideEffects */Block.__(1, [(function (self) {
                                      return Curry._3(validateAsync$3, field$2, value$2, self);
                                    })]);
                    case 3 : 
                        var validateAsync$4 = action[2];
                        var value$3 = action[1];
                        var field$3 = action[0];
                        return /* SideEffects */Block.__(1, [(function (param) {
                                      var send = param[/* send */3];
                                      Curry._1(validateAsync$4, value$3).then((function (result) {
                                              Curry._1(send, /* ApplyAsyncResult */Block.__(4, [
                                                      field$3,
                                                      value$3,
                                                      result
                                                    ]));
                                              return Promise.resolve(/* () */0);
                                            }));
                                      return /* () */0;
                                    })]);
                    case 4 : 
                        var field$4 = action[0];
                        var match$22 = action[1] === Curry._2(Form[/* get */0], field$4, state[/* data */0]);
                        if (match$22) {
                          return /* Update */Block.__(0, [/* record */[
                                      /* data */state[/* data */0],
                                      /* status */state[/* status */1],
                                      /* results */Curry._3(add$1, field$4, /* Some */[action[2]], state[/* results */2]),
                                      /* validating */Curry._2(remove, field$4, state[/* validating */3]),
                                      /* submittedOnce */state[/* submittedOnce */4],
                                      /* emittedFields */Curry._2(add, field$4, state[/* emittedFields */5])
                                    ]]);
                        } else {
                          return /* NoUpdate */0;
                        }
                    case 5 : 
                        var data$1 = action[0];
                        if (data$1) {
                          return /* Update */Block.__(0, [/* record */[
                                      /* data */data$1[0],
                                      /* status : Submitted */2,
                                      /* results */state[/* results */2],
                                      /* validating */state[/* validating */3],
                                      /* submittedOnce */state[/* submittedOnce */4],
                                      /* emittedFields */state[/* emittedFields */5]
                                    ]]);
                        } else {
                          return /* Update */Block.__(0, [/* record */[
                                      /* data */state[/* data */0],
                                      /* status : Submitted */2,
                                      /* results */state[/* results */2],
                                      /* validating */state[/* validating */3],
                                      /* submittedOnce */state[/* submittedOnce */4],
                                      /* emittedFields */state[/* emittedFields */5]
                                    ]]);
                        }
                    case 6 : 
                        return /* Update */Block.__(0, [/* record */[
                                    /* data */state[/* data */0],
                                    /* status : SubmissionFailed */[
                                      action[0],
                                      action[1]
                                    ],
                                    /* results */state[/* results */2],
                                    /* validating */state[/* validating */3],
                                    /* submittedOnce */state[/* submittedOnce */4],
                                    /* emittedFields */state[/* emittedFields */5]
                                  ]]);
                    
                  }
                }
              }),
            /* subscriptions */component[/* subscriptions */13],
            /* jsElementWrapped */component[/* jsElementWrapped */14]
          ];
  };
  return /* module */[
          /* FieldsSetOrigin */FieldsSetOrigin,
          /* FieldsSet */FieldsSet,
          /* ResultsMapOrigin */ResultsMapOrigin,
          /* ResultsMap */ResultsMap,
          /* getInitialState */getInitialState,
          /* debounce */debounce,
          /* debouncedValidators */debouncedValidators,
          /* getValidator */getValidator,
          /* validateDependents */validateDependents,
          /* component */component,
          /* make */make
        ];
}

var Validation = 0;

var Strategy = 0;

var FormStatus = 0;

var Utils = 0;

var defaultDebounceInterval = 700;

exports.Validation = Validation;
exports.Strategy = Strategy;
exports.FormStatus = FormStatus;
exports.Utils = Utils;
exports.defaultDebounceInterval = defaultDebounceInterval;
exports.Make = Make;
/* ReasonReact Not a pure module */
